/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/08/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.vo.NegaraId;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import lombok.Setter;
import com.fasterxml.jackson.annotation.JsonIgnore;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Type;
@Entity
@Table(name = "Negara_M")
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor  @JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class Negara {
	
	private static final String cDefKdNegara = INTEGER;
	@Column(name = "KdNegara", columnDefinition = cDefKdNegara)
	@Id	 
	private Integer kode;
	
	private static final String cDefKdDepartemen = VARCHAR + AWAL_KURUNG + 2 + AKHIR_KURUNG;
	@Column(name = "KdDepartemen", columnDefinition = cDefKdDepartemen)
	@NotNull(message = "negara.kddepartemen.notnull")
	private String kdDepartemen;

	private static final String cDefNamaNegara = VARCHAR + AWAL_KURUNG + 100 + AKHIR_KURUNG;
	@Column(name = "NamaNegara", columnDefinition = cDefNamaNegara)
	@NotNull(message = "negara.namanegara.notnull")
	private String namaNegara;
	
	private static final String cDefVersion =INTEGER;
	@Version
	@Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
	@NotNull(message = "Version Harus Di Isi")
	private Integer version;
	
	private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 100 + AKHIR_KURUNG;
	@Size(max = 100, message = "ReportDisplay max. 100 character")
	@Column(name = "ReportDisplay", length = 100, columnDefinition = cDefReportDisplay)
	private String reportDisplay;

	private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 15 + AKHIR_KURUNG;
	@Size(max = 15, message = "KodeExternal max. 15 character")
	@Column(name = "KodeExternal", length = 15, columnDefinition = cDefKodeExternal)
	private String kodeExternal;

	private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 30 + AKHIR_KURUNG;
	@Size(max = 30, message = "NamaExternal max. 30 character")
	@Column(name = "NamaExternal", length = 30, columnDefinition = cDefNamaExternal)
	private String namaExternal;

	private static final String cDefStatusEnabled = INTEGER ;// AWAL_KURUNG + 1 + AKHIR_KURUNG;
	@Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
	@Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
	
	private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG;
	@Column(name = "NoRec", columnDefinition = cDefNoRec)
	@NotNull(message = "NoRec Harus Diisi")
	private String noRec;

}


